package buildversion

import (
	"runtime"
)

var (
	version   string
	commit    string
	buildDate string
	pipeID    string
)

//Details contains the state of the executable at build time
type Details struct {
	Version   string `json:"version"`
	Commit    string `json:"commit"`
	BuildDate string `json:"buildDate"`
	GoVersion string `json:"goVersion"`
	PipeID    string `json:"pipeID"`
	GOOS      string
	GOARCH    string
}

// Get returns a prepopulated Details struct
func Get() Details {
	return Details{
		Version:   version,
		Commit:    commit,
		BuildDate: buildDate,
		PipeID:    pipeID,
		GoVersion: runtime.Version(),
		GOOS:      runtime.GOOS,
		GOARCH:    runtime.GOARCH,
	}
}
